/* ----------------------------------------------------------------------------
    NSTX -- tunneling network-packets over DNS

     (C) 2000 by Florian Heinz and Julien Oster

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

  -------------------------------------------------------------------------- */

/* $Id: nstx_encode.c,v 2.0 2000/06/18 01:01:36 frodo Exp $ */

#include <string.h>

char remap[] = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ-_1234567890";
int nstx_encode(char *newbuf, char *buf, int len);
int nstx_decode(char *newbuf, char *buf, int len);

static __inline__ int RMAP(int c) {
   int i = 0;
   while ((remap[i] != c) && i < 64)
     i++;
   return i;
}

int nstx_encode(char *newbuf, char *buf, int len) {
   int i = 0, off = 0;
   
   if (len % 3)
     return -1;
   
   while (i < len) {
      newbuf[off + 0] = remap[(buf[i] & 252) >> 2];
      newbuf[off + 1] = remap[((buf[i] & 3) << 4) | ((buf[i+1] & 240) >> 4)];
      newbuf[off + 2] = remap[((buf[i+1] & 15) << 2 ) | ((buf[i+2] & 192) >> 6)];
      newbuf[off + 3] = remap[(buf[i+2] & 63)];
      i += 3;
      off += 4;
   }
   return off;
}

int nstx_decode(char *newbuf, char *buf, int len) {
   int i = 0, off = 0;
   
   if (len % 4)
     return -1;
   
   while (off < len) {
      newbuf[i+0] = (RMAP(buf[off])<<2)|((RMAP(buf[off+1])&48)>>4);
      newbuf[i+1] = ((RMAP(buf[off+1])&15)<<4)|((RMAP(buf[off+2])&60)>>2);
      newbuf[i+2] = ((RMAP(buf[off+2])&3)<<6)|(RMAP(buf[off+3]));
      i += 3;
      off += 4;
   }
   return i;
}
